

rns = nil
fTracks = { }

require 'fTrack'

function refresh_ftracks(event)
  if event then
    if event.type == "insert" then
      local create = fTrack(event.index)
    elseif event.type == "remove" then
      for ftrack_id, ftrack in pairs(fTracks) do
        local found = false
        for track_i, track in ipairs(rns.tracks) do
         if rawequal(ftrack.track, track) then
           found = true
          end
        end
        if not found then
          fTracks[ftrack_id] = nil -- garbage collect
        end
      end
    end
  else
    for track_index, track in ipairs(rns.tracks) do
      local create = fTrack(track_index)
    end    
  end
  debug_ftrack()
end

function refresh_all_patterntracks()
  for _, ftrack in pairs(fTracks) do
    ftrack:refresh_patterntracks()
  end
  debug_ftrack()
end

function debug_ftrack() -- custom verbose "debugging"
  print(" ")
  print(" ")
  local fpatterntracks = 0
  for ftrack_id, ftrack in pairs(fTracks) do
    print("---------------------------------")
    print("Track: " .. ftrack.track_index)
    print("ID: " .. ftrack_id)
    print("patterntracks: ")
    for patterntrack_id, patterntrack in pairs(ftrack.patterntracks) do
      fpatterntracks = fpatterntracks + 1
      oprint(patterntrack.pattern_index)
    end
  end
  print("Number of fTracks: " .. table.count(fTracks))
  print("Number of fpatterntracks: " .. fpatterntracks)
end

function main()
  rns = renoise.song()
  fTracks = { }
  refresh_ftracks()  
  renoise.song().sequencer.pattern_sequence_observable:add_notifier(refresh_all_patterntracks)
  renoise.song().tracks_observable:add_notifier(refresh_ftracks)
  renoise.song().sequencer.pattern_assignments_observable:add_notifier(refresh_all_patterntracks)
end

renoise.tool().app_new_document_observable:add_notifier(main)
